/* $Id: DeplDockCRole.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.Connector.Boot;

import SOFA.Connector.TaggedProfile;
import SOFA.Connector.LinkException; 

/** CRole for DeplDock.
  *
  * @author Petr Hnetynka
  */
public class DeplDockCRole extends SOFA.Connector.RoleBaseImpl implements SOFA.SOFAnode.Run.Deployment.DeplDock {
  
  private CNDeplDock tgt = null;

  public DeplDockCRole() {}

  public void link(Object target) throws SOFA.Connector.LinkException {
    try {
      if (target instanceof SOFA.Connector.Reference) {
        SOFA.Connector.Reference ref = (SOFA.Connector.Reference) target;
        setSOFAReference(ref);
        TaggedProfile[] profiles = ref.profiles;
        for (int i = 0; i<profiles.length; i++) {
          if (profiles[i].tag.compareTo("LOCAL")==0 ) {
            tgt = (CNDeplDock) ((SOFA.Connector.ECG.Profiles.LocalProfile) profiles[i]).link;
            return;
          } else if (profiles[i].tag.compareTo("RMI")==0 ) {
            tgt = new DeplDockRMIStub(((SOFA.Connector.ECG.Profiles.RMIProfile) profiles[i]).URL);
            return;
          }
        }
      } else {
        tgt=(CNDeplDock)target;
      }
    } catch (Exception e) {
      throw new LinkException("Can't link DeplDockCRole.",e);
    }
  }

  public SOFA.SOFAnode.Run.Deployment.TechnologyDescriptor[] describeUnderlyingEnvironment() {
    return tgt.describeUnderlyingEnvironment();
  }
  
  public SOFA.Connector.Reference instantiate(SOFA.SOFAnode.Run.Deployment.DeploymentDescriptor dd, String name) throws SOFA.SOFAnode.Run.Deployment.DeploymentException {
    return tgt.instantiate(dd, name);
  }

  public String[] namesOfAllRunningComponents() {
    return tgt.namesOfAllRunningComponents();
  }
  
  public String[] namesOfAllRunningApplications() {
    return tgt.namesOfAllRunningApplications();
  }

  public SOFA.Connector.Reference getReference(String name) throws SOFA.SOFAnode.Run.Deployment.DeploymentException {
    return tgt.getReference(name);
  }

  public void removeComponent(String name) throws SOFA.SOFAnode.Run.Deployment.DeploymentException {
    tgt.removeComponent(name);
  }
  
}
