/* $Id: DeplDockRMISkel.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.Connector.Boot;

import SOFA.Connector.ConnectorTransportException;

/** RMI skeleton for depldock connector.
  *
  * @author Petr Hnetynka
  */
public class DeplDockRMISkel extends java.rmi.server.UnicastRemoteObject implements CNDeplDockRemote, SOFA.Connector.Linkable {
  
  private CNDeplDock tgt = null;
  
  public DeplDockRMISkel(String url) throws java.rmi.RemoteException, java.net.MalformedURLException, java.rmi.NotBoundException {
    super();
    String rmihost = System.getProperty("sofa.rmihost", "localhost");
    String rmiport = System.getProperty("sofa.rmiport", "1099");
    SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock rg = (SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock) java.rmi.Naming.lookup("//"+rmihost+":"+rmiport+"/RgRMIDock");
    rg.rebind("/SOFA/Connectors/Boot/DeplDockRMISkel/"+url, this);
//    java.rmi.Naming.rebind("rmi://"+rmihost+":"+rmiport+"/SOFA/Connectors/Boot/DeplDockRMISkel/"+url, this);
  }

  public void link(Object target) {
    tgt = (CNDeplDock) target;
  }
  
  public byte[][] describeUnderlyingEnvironment() throws java.rmi.RemoteException {
    SOFA.SOFAnode.Run.Deployment.TechnologyDescriptor[] td = tgt.describeUnderlyingEnvironment();
    byte[][] ret = new byte [td.length] [];
    try {
      for (int i=0; i<td.length; i++) {
        cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
        td[i]._write(os);
        ret[i] = os.toByteArray();
      }
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the describeUnderlyingEnvironment.", e);
    }
    return ret;
  }

  public byte[] instantiate(byte[] dd, String name) throws SOFA.SOFAnode.Run.Deployment.DeploymentException, java.rmi.RemoteException {
    SOFA.SOFAnode.Run.Deployment.DeploymentDescriptorImpl ddr = new SOFA.SOFAnode.Run.Deployment.DeploymentDescriptorImpl();
    try {
      ddr._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(dd));
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the instantiate.", e);
    }
    
    SOFA.Connector.Reference ref = tgt.instantiate(ddr, name);
    
    ref = removeLocal(ref);
    cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = null;
    try {
      os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      ref._write(os);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the instantiate.", e);
    }
    return os.toByteArray();
  }

  public byte[] getReference(String name) throws SOFA.SOFAnode.Run.Deployment.DeploymentException, java.rmi.RemoteException {
  
    SOFA.Connector.Reference ref = tgt.getReference(name);
    
    ref = removeLocal(ref);
    cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = null;
    try {
      os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      ref._write(os);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the getReference.", e);
    }
    return os.toByteArray();
  }


  public String[] namesOfAllRunningComponents() {
    return tgt.namesOfAllRunningComponents();
  }
  
  public String[] namesOfAllRunningApplications() {
    return tgt.namesOfAllRunningApplications();
  }

  public void removeComponent(String name) throws SOFA.SOFAnode.Run.Deployment.DeploymentException, java.rmi.RemoteException  {
    tgt.removeComponent(name);
  }

  /** Remove LOCAL profile from reference. */
  public static SOFA.Connector.Reference removeLocal(SOFA.Connector.Reference ref) {
    boolean b = false;
    for(int i=0; i<ref.profiles.length; i++) {
      if (ref.profiles[i] instanceof SOFA.Connector.ECG.Profiles.LocalProfile) {
        b = true;
      }
    }
    if (b) {
      SOFA.Connector.TaggedProfile[] p = new SOFA.Connector.TaggedProfile [ref.profiles.length];
      int j = 0;
      for (int i=0; i<ref.profiles.length; i++) {
        if (!(ref.profiles[i] instanceof SOFA.Connector.ECG.Profiles.LocalProfile)) {
          p[j] = ref.profiles[i];
          j++;
        }
      }
      ref.profiles = p;
    } 
    return ref;
  }
}
