/*
 * LocalSkeletonGen.java
 *
 * Created on 13. duben 2002, 21:08
 */

package SOFA.Connector.EEG.EEM.Elements;

import SOFA.SOFAnode.Made.TIR.*;
import SOFA.SOFAnode.Made.TIR.Access.TIRAccessMethods;
import SOFA.Connector.EEG.CodeWriter.*;
import SOFA.Connector.EEG.EEM.Actions.*;

/**
 *
 * @author  ghort
 * @version 
 */
public class LocalSkeletonGen extends JImplWriterDirectorBase {

	/** Creates new LocalSkeletonGen */
	public LocalSkeletonGen(String provIfaceCDL, SOFA.Connector.Property[] params) {
		super(provIfaceCDL,params);
	}

	public String[] getImplements() {
		return new String[] {"SOFA.Connector.EEG.Types.Skeleton"};
	}
	
	public String getClassBody() {
		return managerTieImpl() + "\n" + linkImpl() + "\n" +
			"\tpublic SOFA.Connector.TaggedProfile[] getProfiles() {\n"+
			"\t\treturn new SOFA.Connector.TaggedProfile[] { new SOFA.Connector.ECG.Profiles.LocalProfile(this) };\n"+
			"\t}\n\n"+
                        "\tpublic org.objectweb.fractal.api.Type getFcItfType() { return null; }\n"+
                        "\tpublic boolean isFcInternalItf() {return false; }\n"+
                        "\tpublic String getFcItfName() { return this.target.getFcItfName(); }\n"+
                        "\tpublic org.objectweb.fractal.api.Component getFcItfOwner() { return this.target.getFcItfOwner(); }\n\n";
	}

	public String getMethodDef(OperationDef mt) throws JWriterDirectorException {
		return JIfaceCN.getMethodDef(mt);
	}

	public String getMethodBody(OperationDef method) throws JWriterDirectorException {
		return 
			"\t\t"+declareRet(method,"ret")+"\n"+
			"\t\t"+assignRet(method,"ret")+targetCall(method,JIfaceCN.targetCallParams(method))+";\n"+
			"\t\t"+returnRet(method,"ret");
	}
}
