/* $Id: CompExprEnum.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL; 
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompExprEnum extends CompExprOper {
  public CompReffer en;
  public String item;    // enum item
  public CompExprEnum(CompReffer en, String it) {
    super(CompExprKind.e_enum);
    this.en = en;
    item = it;
  }

  public int type() { return CompExprKind.e_enum; }
  public boolean isProp() { return false; }
  public EnumList nameProp(CompRepository rep) throws CDLExceptRemote, CDLExceptLock {
    EnumList l = new EnumList();
    return l;
  }

  public String toString() {
    return item;
  }
  
  public int isPositive() {
    return -2;
  }

  public ExprOperDef toNormal(CDLRepository rep) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
    try {
      int i,j;
      Container con = rep;
      en.ref.sn.names.toFirst();
      for(i=0;i<en.ref.sn.names.size();i++) {
        Contained[] a = con.lookup_name((String) en.ref.sn.names.aktual());
        if (a.length==1) {
          con = (Container) a[0];
        } else {
          for(j=0;j<a.length;j++) {
            if (a[j].get_identification().version().compareTo(en.ref.version)==0) {
              con = (Container) a[j];
              break;
            }
          }
        }
        en.ref.sn.names.toNext();
      }
      Contained sec = con.lookup(en.ref.name, en.ref.version);
      return ((Repository) rep.get_containing_repository()).create_exprenum((EnumDef) sec, item);
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate ecr) {
      throw new CDLExceptToNormal("Can't create expression");
    } catch (TIRExceptLock e) {
      throw new CDLExceptLock("Repository is locked.");
    }
  }
}
