/* $Id: CompWstring.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompWstring extends CompObjectIm implements CompType {
  public CompExprOper bound;

  public CompWstring(CompExprOper e) {
    super(ObjectsKind.o_Wstring);
    bound = e;
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    if (!CompExprOper.testPropInExpr(props, bound.nameProp(rep)))
      throw new CDLExceptCheck("Unknown property");
  }

  public CDLType toNormal(CDLRepository newRep) throws CDLExceptRemote, CDLExceptToNormal, CDLExceptLock {
    try {
      return newRep.create_wstring(bound.toNormal(newRep));
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate e) {
      throw new CDLExceptToNormal("Can't get primitve type\n"+e.getMessage());
    }
  }
}
