/* $Id: ID.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.Identification;

class ID {
  public static final String lang = "cdl";

  public int isin;   // what is in id  -- version || tag || none
                     // constants in ReadIDKind.java 
  public String name;
  public String version;
  public String tag;

  public int what;   // what kind 
  public boolean exist;  // for module, provider, amodule

  public Identification id; // real id
  
  public ID(String name, String vt) {
    what = 0; exist = false; id = null;
    this.name = new String(name);
    id = null;
    if (vt == null || vt.length()==0) {
      isin = IDKind.none;
      tag = null;
      version = null;
    } else {  
      if (vt.indexOf('!')==-1) {
        version = null;
        isin = IDKind.tag;
        tag = new String(vt);
      } else {
        version = new String(vt);
        isin = IDKind.version;
        tag = null;
      }
    }  
  }

  public void setVersion(String vt) {
    what = 0; exist = false; id = null;
    if (vt == null || vt.length()==0) {
      isin = IDKind.none;
      tag = null;
      version = null;
    } else {  
      if (vt.indexOf('!')==-1) {
        version = null;
        isin = IDKind.tag;
        tag = new String(vt);
      } else {
        version = new String(vt);
        isin = IDKind.version;
        tag = null;
      }
    }
  }

  public boolean isEqual(String nm, String ver) {
    if (isin==IDKind.version || isin==IDKind.versiontag)
      if ((nm.compareTo(name)==0)&&(ver.compareTo(version)==0)) 
        return true;
    return false;
  }

  public boolean isNameEqual(String nm) {
    if (nm.compareTo(name)==0) 
      return true;
    return false;
  }

  public boolean isTagEqual(String nm, String t) {
    if (isin==IDKind.tag || isin==IDKind.versiontag)
      if ((nm.compareTo(name)==0)&&(t.compareTo(tag)==0)) 
        return true;
    return false;
  }

  public String toString() {
    StringBuffer ret = new StringBuffer(name);
    switch (isin) {
      case IDKind.versiontag:
      case IDKind.version: ret.append("::"+version); break;
      case IDKind.tag: ret.append("::"+tag); break;
    }
    return ret.toString();
  }
}
