/* $Id: cdl.lex,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;

import java_cup.runtime.Symbol;

class Convert {
  static char pow(char x, int n) {  /* x**n */
    int i;
    char ret = 1;
    for(i=0;i<n;i++) {
      ret *= x;
    }
    return ret;
  }

  static boolean isHexaDigit(char c) {
    if ((c>='0')&&(c<='9'))
      return true;
    if ((c>='a')&&(c<='f'))
      return true;
    if ((c>='A')&&(c<='F')) 
      return true;
    return false;
  }

  public static boolean isOctalDigit(char c) {
    if ((c>='0')&&(c<='7'))
      return true;
    return false;
  }
  
  public static Character toCharacter(String str) {
    char ret = 0;
    int i,j=0;
    if (str.charAt(j) == 'L')
      j++;
    j++;  /* move behind ' */  
    if (str.charAt(j)=='\\') {
      switch (str.charAt(j+1)) {
        case '\\': ret = '\\';
                   break;
        case 'n': ret = '\n';
	          break;
	case 'r': ret = '\r';
	          break;
	case 't': ret = '\t';
	          break;
	case 'f': ret = '\f';
	          break;
	case 'b': ret = '\b';
	          break;
	case 'a': ret = 7;    /* alert - no escape sequence in Java */
	          break;
	case 'v': ret = 11;   /* vert. tab - no escape sequence in Java */
	          break;
	case '?': ret = '?';
	          break;
	case '\"': ret = '\"';
		   break;
	case '\'': ret = '\'';
	           break;
	case 'x': i = j+2;
	          while (str.charAt(i) != '\'') {
	            ret *= 16;
	            if (!Character.isDigit(str.charAt(i))) {
		      ret += Character.toLowerCase(str.charAt(i)) - 'a' + 10;
		    } else {
                      ret += str.charAt(i) - '0';
		    }
		    i++;
		  }
		  break;
	case 'u': i = j+2;
	          while (str.charAt(i) != '\'') {
	            ret *= 16;
	            if (!Character.isDigit(str.charAt(i))) {
		      ret += Character.toLowerCase(str.charAt(i)) - 'a' + 10;
		    } else {
                      ret += str.charAt(i) - '0';
		    }
		    i++;
		  }
		  break;
	default : /* octal number */
		  i = j+1;
	          while (str.charAt(i) != '\'') {
	            ret *= 8;
                    ret += str.charAt(i) - '0';
		    i++;
		  }
      }
    } else {
      ret = str.charAt(0);
    }
    return new Character(ret);
  }

  public static String toString(String str) {
    int i,j;
    char c = 0;
    boolean uv = false;
    StringBuffer ret = new StringBuffer();
    i = 0;
    if (str.charAt(i)=='L')
      i++;
    while (i<str.length()) {
      if (!uv) {
        if (str.charAt(i)=='\"') {
	  uv = true;
	}
        i++;
      } else {
        if (str.charAt(i)=='\\') {
          i++;
	  switch (str.charAt(i)) {
          case '\\': ret = ret.append('\\');
                     break;
          case 'n': ret = ret.append('\n');
	            break;
	  case 'r': ret = ret.append('\r');
	            break;
	  case 't': ret = ret.append('\t');
	            break;
	  case 'f': ret = ret.append('\f');
	            break;
	  case 'b': ret = ret.append('\b');
	            break;
	  case 'a': ret = ret.append((char)7);  /* alert - no escape sequence in Java */
	            break;
	  case 'v': ret = ret.append((char)11); /* vert. tab - no escape sequence in Java */
	            break;
	  case '?': ret = ret.append('?');
	            break;
	  case '\"': ret = ret.append('\"');
	      	     break;
	  case '\'': ret = ret.append('\'');
	             break;
	  case 'x' : j = ++i;
	             while (i<str.length() && (i-j<2) && isHexaDigit(str.charAt(i))) {
	               c *= 16;
	               if (!Character.isDigit(str.charAt(i))) {
		         c += Character.toLowerCase(str.charAt(i)) - 'a' + 10;
		       } else {
                         c += str.charAt(i) - '0';
		       }
		       i++;
		     }
		     ret = ret.append(c);
		     i--;
	             break;
	  case 'u' : j = ++i;
	             while (i<str.length() && (i-j<4) && isHexaDigit(str.charAt(i))) {
	               c *= 16;
	               if (!Character.isDigit(str.charAt(i))) {
		         c += Character.toLowerCase(str.charAt(i)) - 'a' + 10;
		       } else {
                         c += str.charAt(i) - '0';
		       }
		       i++;
		     }
		     ret = ret.append(c);
		     i--;
	             break;
          case '0' :
          case '1' :
          case '2' :
          case '3' : j = i;
	             while (i<str.length() && (i-j<3) && isOctalDigit(str.charAt(i))) {
	               c *= 8;
	               c += str.charAt(i) - '0';
		       i++;
		     }
		     ret = ret.append(c);
		     i--;
	             break;
          case '4' :
          case '5' :
          case '6' :
          case '7' : j = i;
	             while (i<str.length() && (i-j<2) && isOctalDigit(str.charAt(i))) {
	               c *= 8;
	               c += str.charAt(i) - '0';
		       i++;
		     }
		     ret = ret.append(c);
		     i--;
	             break;
          }
        } else if (str.charAt(i)=='\"'){
          uv = false;
        } else {
          ret = ret.append(str.charAt(i));
        }
        i++;
      }	
    }
    return ret.toString();
  }
}
 



%%
%cup
%char
%line
%state STATE_IN_ARR_EXP
%{
public LineInfo lineinfo;
%}
%init{
lineinfo = new LineInfo();
%init}
STRING_PART = \"(([^\\\"]*)|(\\[ntvbrfa'\"\?\\x01234567]))*\"
WSTRING_PART = L\"(([^\\\"]*)|(\\[untvbrfa'\"\?\\x01234567]))*\"
WHITE_SPACE = [\ \t\r\n\f]
%%

/\*[^\*]*\*([^\*/]*\*)*/ { /* System.out.println("Comment found: "+yytext()+"\n");*/ }

//.*$     { /* comments */ }

";" { lineinfo.add(yyline,yychar); return new Symbol(sym.SEMICOLON,yychar,yychar+yytext().length()); }
":" { lineinfo.add(yyline,yychar); return new Symbol(sym.COLON,yychar,yychar+yytext().length()); }
"," { lineinfo.add(yyline,yychar); return new Symbol(sym.COMMA,yychar,yychar+yytext().length()); }
"(" { lineinfo.add(yyline,yychar); return new Symbol(sym.LPAREN,yychar,yychar+yytext().length()); }
")" { lineinfo.add(yyline,yychar); return new Symbol(sym.RPAREN,yychar,yychar+yytext().length()); }
"[" { lineinfo.add(yyline,yychar); yybegin(STATE_IN_ARR_EXP); return new Symbol(sym.LBRACKET,yychar,yychar+yytext().length()); }
"]" { lineinfo.add(yyline,yychar); yybegin(YYINITIAL); return new Symbol(sym.RBRACKET,yychar,yychar+yytext().length()); }
"{" { lineinfo.add(yyline,yychar); return new Symbol(sym.LBRACE,yychar,yychar+yytext().length()); }
"}" { lineinfo.add(yyline,yychar); return new Symbol(sym.RBRACE,yychar,yychar+yytext().length()); }
"<" { lineinfo.add(yyline,yychar); return new Symbol(sym.LESSTHAN,yychar,yychar+yytext().length()); }
">" { lineinfo.add(yyline,yychar); return new Symbol(sym.GREATERTHAN,yychar,yychar+yytext().length()); }
"+" { lineinfo.add(yyline,yychar); return new Symbol(sym.PLUS,yychar,yychar+yytext().length()); }
"-" { lineinfo.add(yyline,yychar); return new Symbol(sym.MINUS,yychar,yychar+yytext().length()); }
"*" { lineinfo.add(yyline,yychar); return new Symbol(sym.MUL,yychar,yychar+yytext().length()); }
"/" { lineinfo.add(yyline,yychar); return new Symbol(sym.DIV,yychar,yychar+yytext().length()); }
"%" { lineinfo.add(yyline,yychar); return new Symbol(sym.MOD,yychar,yychar+yytext().length()); }
"~" { lineinfo.add(yyline,yychar); return new Symbol(sym.TILDE,yychar,yychar+yytext().length()); }
"&" { lineinfo.add(yyline,yychar); return new Symbol(sym.AND,yychar,yychar+yytext().length()); }
"|" { lineinfo.add(yyline,yychar); return new Symbol(sym.OR,yychar,yychar+yytext().length()); }
"^" { lineinfo.add(yyline,yychar); return new Symbol(sym.XOR,yychar,yychar+yytext().length()); }
"=" { lineinfo.add(yyline,yychar); return new Symbol(sym.EQUAL,yychar,yychar+yytext().length()); }
"$" { lineinfo.add(yyline,yychar); return new Symbol(sym.DOLLAR,yychar,yychar+yytext().length()); }
"!" { lineinfo.add(yyline,yychar); return new Symbol(sym.EXCLAM,yychar,yychar+yytext().length()); }
"?" { lineinfo.add(yyline,yychar); return new Symbol(sym.QUESTION,yychar,yychar+yytext().length()); }
"." { lineinfo.add(yyline,yychar); return new Symbol(sym.DOT,yychar,yychar+yytext().length()); }
<STATE_IN_ARR_EXP> ".." { lineinfo.add(yyline,yychar); return new Symbol(sym.DOT_DOT,yychar,yychar+yytext().length()); }
"::" { lineinfo.add(yyline,yychar); return new Symbol(sym.DOUBLE_COLON,yychar,yychar+yytext().length()); }
"||" { lineinfo.add(yyline,yychar); return new Symbol(sym.OROR,yychar,yychar+yytext().length()); }
"<<" { lineinfo.add(yyline,yychar); return new Symbol(sym.SHIFT_LEFT,yychar,yychar+yytext().length()); }
">>" { lineinfo.add(yyline,yychar); return new Symbol(sym.SHIFT_RIGHT,yychar,yychar+yytext().length()); }

module    { lineinfo.add(yyline,yychar); return new Symbol(sym.MODULE,yychar,yychar+yytext().length()); }
interface { lineinfo.add(yyline,yychar); return new Symbol(sym.INTERFACE,yychar,yychar+yytext().length()); }
typedef   { lineinfo.add(yyline,yychar); return new Symbol(sym.TYPEDEF,yychar,yychar+yytext().length()); }
const     { lineinfo.add(yyline,yychar); return new Symbol(sym.CONST,yychar,yychar+yytext().length()); }
struct    { lineinfo.add(yyline,yychar); return new Symbol(sym.STRUCT,yychar,yychar+yytext().length()); }
union     { lineinfo.add(yyline,yychar); return new Symbol(sym.UNION,yychar,yychar+yytext().length()); }
switch    { lineinfo.add(yyline,yychar); return new Symbol(sym.SWITCH,yychar,yychar+yytext().length()); }
case      { lineinfo.add(yyline,yychar); return new Symbol(sym.CASE,yychar,yychar+yytext().length()); }
default   { lineinfo.add(yyline,yychar); return new Symbol(sym.DEFAULT,yychar,yychar+yytext().length()); }
enum      { lineinfo.add(yyline,yychar); return new Symbol(sym.ENUM,yychar,yychar+yytext().length()); }
readonly  { lineinfo.add(yyline,yychar); return new Symbol(sym.READONLY,yychar,yychar+yytext().length()); }
sequence  { lineinfo.add(yyline,yychar); return new Symbol(sym.SEQUENCE,yychar,yychar+yytext().length()); }
attribute { lineinfo.add(yyline,yychar); return new Symbol(sym.ATTRIBUTE,yychar,yychar+yytext().length()); }
exception { lineinfo.add(yyline,yychar); return new Symbol(sym.EXCEPTION,yychar,yychar+yytext().length()); }
inout     { lineinfo.add(yyline,yychar); return new Symbol(sym.INOUT,yychar,yychar+yytext().length()); }
in        { lineinfo.add(yyline,yychar); return new Symbol(sym.IN,yychar,yychar+yytext().length()); }
out       { lineinfo.add(yyline,yychar); return new Symbol(sym.OUT,yychar,yychar+yytext().length()); }
raises    { lineinfo.add(yyline,yychar); return new Symbol(sym.RAISES,yychar,yychar+yytext().length()); }

TRUE     { lineinfo.add(yyline,yychar); return new Symbol(sym.TRUE,yychar,yychar+yytext().length()); }
FALSE    { lineinfo.add(yyline,yychar); return new Symbol(sym.FALSE,yychar,yychar+yytext().length()); }
Object   { lineinfo.add(yyline,yychar); return new Symbol(sym.OBJECT,yychar,yychar+yytext().length()); }
float    { lineinfo.add(yyline,yychar); return new Symbol(sym.FLOAT,yychar,yychar+yytext().length()); }
double   { lineinfo.add(yyline,yychar); return new Symbol(sym.DOUBLE,yychar,yychar+yytext().length()); }
fixed    { lineinfo.add(yyline,yychar); return new Symbol(sym.FIXED,yychar,yychar+yytext().length()); }
long     { lineinfo.add(yyline,yychar); return new Symbol(sym.LONG,yychar,yychar+yytext().length()); }
short    { lineinfo.add(yyline,yychar); return new Symbol(sym.SHORT,yychar,yychar+yytext().length()); }
unsigned { lineinfo.add(yyline,yychar); return new Symbol(sym.UNSIGNED,yychar,yychar+yytext().length()); }
char     { lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR,yychar,yychar+yytext().length()); }
string   { lineinfo.add(yyline,yychar); return new Symbol(sym.STRING,yychar,yychar+yytext().length()); }
wchar    { lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR,yychar,yychar+yytext().length()); }
wstring  { lineinfo.add(yyline,yychar); return new Symbol(sym.WSTRING,yychar,yychar+yytext().length()); }
boolean  { lineinfo.add(yyline,yychar); return new Symbol(sym.BOOLEAN,yychar,yychar+yytext().length()); }
octet    { lineinfo.add(yyline,yychar); return new Symbol(sym.OCTET,yychar,yychar+yytext().length()); }
any      { lineinfo.add(yyline,yychar); return new Symbol(sym.ANY,yychar,yychar+yytext().length()); }
void     { lineinfo.add(yyline,yychar); return new Symbol(sym.VOID,yychar,yychar+yytext().length()); }

frame        { lineinfo.add(yyline,yychar); return new Symbol(sym.FRAME,yychar,yychar+yytext().length()); }
architecture { lineinfo.add(yyline,yychar); return new Symbol(sym.ARCHITECTURE,yychar,yychar+yytext().length()); }
primitive    { lineinfo.add(yyline,yychar); return new Symbol(sym.PRIMITIVE,yychar,yychar+yytext().length()); }
inst         { lineinfo.add(yyline,yychar); return new Symbol(sym.INST,yychar,yychar+yytext().length()); }
bind         { lineinfo.add(yyline,yychar); return new Symbol(sym.BIND,yychar,yychar+yytext().length()); }
subsume      { lineinfo.add(yyline,yychar); return new Symbol(sym.SUBSUME,yychar,yychar+yytext().length()); }
delegate     { lineinfo.add(yyline,yychar); return new Symbol(sym.DELEGATE,yychar,yychar+yytext().length()); }
to           { lineinfo.add(yyline,yychar); return new Symbol(sym.TO,yychar,yychar+yytext().length()); }
rev          { lineinfo.add(yyline,yychar); return new Symbol(sym.REV,yychar,yychar+yytext().length()); }
property     { lineinfo.add(yyline,yychar); return new Symbol(sym.PROPERTY,yychar,yychar+yytext().length()); }
auto         { lineinfo.add(yyline,yychar); return new Symbol(sym.AUTO,yychar,yychar+yytext().length()); }
provides     { lineinfo.add(yyline,yychar); return new Symbol(sym.PROVIDE,yychar,yychar+yytext().length()); }
requires     { lineinfo.add(yyline,yychar); return new Symbol(sym.REQUIRE,yychar,yychar+yytext().length()); }
protocol     { lineinfo.add(yyline,yychar); return new Symbol(sym.PROTOCOL,yychar,yychar+yytext().length()); }
using        { lineinfo.add(yyline,yychar); return new Symbol(sym.USING,yychar,yychar+yytext().length()); }
system       { lineinfo.add(yyline,yychar); return new Symbol(sym.SYSTEM,yychar,yychar+yytext().length()); }
implements   { lineinfo.add(yyline,yychar); return new Symbol(sym.IMPLEMENTS,yychar,yychar+yytext().length()); }

"NULL"       { lineinfo.add(yyline,yychar); return new Symbol(sym.NULL, yychar,yychar+yytext().length()); }


(([0-9]+)|(0x[0-9a-f])|(0X[0-9A-F])) { lineinfo.add(yyline,yychar); return new Symbol(sym.INTEGER_LITERAL,yychar,yychar+yytext().length(), new Long(yytext())); }

<YYINITIAL> (([0-9]+\.[0-9]*)|([0-9]*\.[0-9]+))(([eE][\+\-]?[0-9]+)?) { lineinfo.add(yyline,yychar); return new Symbol(sym.FLOATING_PT_LITERAL,yychar,yychar+yytext().length(), new Double(yytext())); }

'.' { lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR_LITERAL,yychar,yychar+yytext().length(), new Character(yytext().charAt(1))); }
'\\[ntvbrfa'\"\?\\]' { lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
'\\[0-7][0-7]?[0-7]?' { lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
'\\x[0-9a-fA-F][0-9a-fA-F]?' { lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }

L'.' { lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), new Character(yytext().charAt(1)));}
L'\\[ntvbrfa'\"\?\\]' { lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
L'\\[0-7][0-7]?[0-7]?' { lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
L'\\x[0-9a-fA-F][0-9a-fA-F]?' { lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
L'\\u[0-9a-fA-F][0-9a-fA-F]?[0-9a-fA-F]?[0-9a-fA-F]?' { lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }

{STRING_PART}({WHITE_SPACE}*{STRING_PART})* { lineinfo.add(yyline,yychar); return new Symbol(sym.STRING_LITERAL,yychar,yychar+yytext().length(), Convert.toString(yytext())); }

{WSTRING_PART}({WHITE_SPACE}*{WSTRING_PART})* { lineinfo.add(yyline,yychar); return new Symbol(sym.WSTRING_LITERAL,yychar,yychar+yytext().length(), Convert.toString(yytext())); }

(([0-9]*\.[0-9]+)|([0-9]+\.[0-9]*)|([0-9]+))[dD] {return new Symbol(sym.FIXED_PT_LITERAL,yychar,yychar+yytext().length(), new Fixed(yytext())); }

[a-zA-Z_][a-zA-Z0-9_]* { lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }


{WHITE_SPACE} { /* ignore white spaces */ }
.           { /* !!! co kdyz nic nepasuje */ System.out.println("NIC"); }

