package SOFA.SOFAnode.Made.TIR.Access.Browser;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Naming;
import java.rmi.RemoteException;

/** Print all profiles */
public class Profiles {

  public static void main(String[] argv) {
    try { 
      System.setSecurityManager(new java.rmi.RMISecurityManager());
    
      String rmiport = System.getProperty("sofa.rmiport","1099");
      String rmihost = System.getProperty("sofa.rmihost","localhost");
      System.out.print("Connecting to repository...");
      Repository rep = (Repository) Naming.lookup("//"+rmihost+":"+rmiport+"/Repository");
      System.out.println("OK");
      System.out.print("Getting profiles object...");
      ManageProfiles prof = rep.getProfiles();
      System.out.println("OK");
      System.out.print("Getting profiles...");
      ProfileDef[] p = prof.all_profiles();
      System.out.println("OK");
      System.out.println("Print profiles:");
      System.out.println("===============");
      for (int i=0;i<p.length;i++) {
        System.out.println("Profile \""+p[i].name()+"\"");
        Identification[] id = p[i].contents();
        for(int j=0;j<id.length;j++) {
          System.out.println("  "+id[j].absolute_name().name()+":"+id[j].version());
        }
      }
    } catch (Exception e) { 
      System.out.println("Exception: " + e.getMessage()); 
      e.printStackTrace(); 
    }
  }
}
