package SOFA.SOFAnode.Made.TIR.Access.TIRBrowser;

import javax.swing.JSplitPane;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.JTable;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.table.AbstractTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeNode;
import javax.swing.tree.DefaultTreeModel;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;
// import javax.swing.plaf.basic.BasicTreeUI.TreeExpansionHandler;
import javax.swing.event.TreeWillExpandListener;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.tree.ExpandVetoException;
import javax.swing.ImageIcon;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;


public class TIRBrowser extends JSplitPane {
  JTable prop;
  JScrollPane propScroll;
  TreeBrowser tree;
  JScrollPane treeScroll;
  MyTableModel tableModel;

  public TIRBrowser(String host, String port, Repository rep) {
    super(JSplitPane.VERTICAL_SPLIT);
    tableModel = new MyTableModel(host, port);
    tree = new TreeBrowser(new RootNode(host+":"+port, rep), tableModel);
    prop = new JTable(tableModel);
    treeScroll = new JScrollPane(tree);
    propScroll = new JScrollPane(prop);
    setTopComponent(treeScroll);
    setBottomComponent(propScroll);
  }
}

class TreeBrowser extends JTree {
  DefaultMutableTreeNode root;
  MyTableModel model;

  public TreeBrowser(DefaultMutableTreeNode root, MyTableModel tablemodel) {
    super(root);
    model = tablemodel;
    this.root = root;
    setCellRenderer(new TreeBrowserRenderer());
    putClientProperty("JTree.lineStyle", "Angled");

    addTreeWillExpandListener(new TreeWillExpandListener() {
        public void treeWillExpand(TreeExpansionEvent event) throws ExpandVetoException {
          Object obj = event.getPath().getLastPathComponent();
          if (obj instanceof TIRObjectNode) {
            TIRObjectNode o = (TIRObjectNode) obj;
            if (!o.hasContent()) {
              o.loadContent();
            }
          }
          if (obj instanceof ProfilesNode) {
            ProfilesNode o = (ProfilesNode) obj;
            if (!o.hasContent()) {
              o.loadContent();
            }
          }
          if (obj instanceof ProfileNode) {
            ProfileNode o = (ProfileNode) obj;
            if (!o.hasContent()) {
              o.loadContent();
            }
          }
        }
        public void treeWillCollapse(TreeExpansionEvent event) throws ExpandVetoException {
          ;
        }
      }
    );

    addTreeSelectionListener(new SelListener(model));

    addMouseListener(new TIRMouseAdapter(this));

   
  }

  public void clearTP() {
    clearToggledPaths();
  }

  class TIRMouseAdapter extends MouseAdapter {
    TreeBrowser tree;
    
    public TIRMouseAdapter(TreeBrowser t) {
      tree = t;
    }

    public void mousePressed(MouseEvent e) {
      int selRow = tree.getRowForLocation(e.getX(), e.getY());
      javax.swing.tree.TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
      if(selRow != -1) {
        if ((e.getModifiers() & java.awt.event.InputEvent.BUTTON3_MASK)==java.awt.event.InputEvent.BUTTON3_MASK) {
          tree.setSelectionRow(selRow);
          Object obj = selPath.getLastPathComponent();
          /*
          if (obj instanceof TIRObjectNode) {
            if (((TIRObjectNode) obj).obj instanceof ArchitectureDef) {
              ArchitectureDef arch = (ArchitectureDef) ((TIRObjectNode) obj).obj;
              ArchitectureDef[] archs = new ArchitectureDef [1];
              archs[0] = arch;
              dd.setVisible(true);
              dd.repaint();
              try {
                SOFA.SOFAnode.Made.CodeGen.Generator g = new SOFA.SOFAnode.Made.CodeGen.Generator((Repository) arch.get_containing_repository(), archs);
                g.generate();
                dd.setVisible(false);
              } catch (Exception ex) {
                JOptionPane.showMessageDialog(null, "alert", "Exception occured:\n"+ex.getMessage(), JOptionPane.ERROR_MESSAGE);
              }
            }
          }
          */
          if (obj instanceof BaseNode) {
            String[] names = ((BaseNode) obj).getMenuNames();
            if (names != null) {
              TreeActionListener alistener = new TreeActionListener((BaseNode)obj, tree, selPath);
              JPopupMenu menu = new JPopupMenu();
              for (int i=0; i<names.length; i++) {
                JMenuItem item = new JMenuItem(names[i]);
                item.addActionListener(alistener);
                menu.add(item);
              }
              menu.show(tree, e.getX(), e.getY());
            }
          }
        }
      }
    }  
  }

  class TreeActionListener implements ActionListener {
    BaseNode node;
    javax.swing.tree.TreePath selPath;
    JTree tree;
    
    public TreeActionListener(BaseNode node, JTree tree, javax.swing.tree.TreePath selPath) {
      this.node = node;
      this.tree = tree;
      this.selPath = selPath;
    }
    public void actionPerformed(ActionEvent e) {
      node.performAction(e.getActionCommand(), tree, selPath);
    }
  }

 
  
  class SelListener implements TreeSelectionListener {
    MyTableModel model;
    public SelListener(MyTableModel m) { model = m; }
    public void valueChanged(TreeSelectionEvent event) {
      Object obj = event.getPath().getLastPathComponent();
      if (obj instanceof TIRObjectNode) {
        TIRObjectNode o = (TIRObjectNode) obj;
        model.setObj(o.obj);
      }
      if (obj instanceof RootNode) {
        RootNode o = (RootNode) obj;
        model.setObj(o.rep);
      }
    }
  }


}

class TreeBrowserRenderer extends DefaultTreeCellRenderer {
  class NodeDecoration {
    ImageIcon openIcon;
    ImageIcon closeIcon;
    String  toolTip;
    public NodeDecoration(String oi, String ci, String tt) {
      closeIcon = new ImageIcon(ClassLoader.getSystemResource(ci));
      openIcon = new ImageIcon(ClassLoader.getSystemResource(oi));
      toolTip = tt;
    }
  }

  class NodeDecorationStore extends java.util.Hashtable {
    public static final String  ID = "id";
    
    public void add(int dk, NodeDecoration nd) {
      put (new Integer(dk), nd);
    }

    public void addSpecial(String dk, NodeDecoration nd) {
      put (dk, nd);
    }

    public NodeDecoration getND(int dk) {
      return (NodeDecoration) get(new Integer(dk));
    }

    public NodeDecoration getNDSpecial(String dk) {
      return (NodeDecoration) get(dk);
    }
  }
  
  NodeDecorationStore nd;
  
  public TreeBrowserRenderer() {
    nd = new NodeDecorationStore();
    nd.add(DefinitionKind.dk_Module, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ModuleOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ModuleCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_AModule, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ModuleOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ModuleCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Provider, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ProviderOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ProviderCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Frame, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/FrameOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/FrameCloseIcon.gif",null));
/*    nd.add(DefinitionKind.dk_Frame, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/FrameOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/FrameCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Frame, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/FrameOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/FrameCloseIcon.gif",null));*/
    nd.add(DefinitionKind.dk_Architecture, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ArchitectureOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ArchitectureCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Repository, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/RepOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/RepCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Interface, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/InterfaceOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/InterfaceCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Attribute, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Operation, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Struct, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Exception, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ExcepOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ExcepCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Union, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Enum, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/PointCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Bind, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/BindOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/BindCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Inst, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/InstOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/InstCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_StructMember, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/MemberOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/MemberCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_UnionMember, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/MemberOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/MemberCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Typedef, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/TypedefOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/TypedefCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Constant, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ConstantOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ConstantCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Provides, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ProvidesOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ProvidesCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Requires, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/RequiresOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/RequiresCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Property, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/MemberOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/MemberCloseIcon.gif",null));
    nd.add(DefinitionKind.dk_Profile, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ProfileOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/ProfileCloseIcon.gif",null));
    nd.addSpecial(NodeDecorationStore.ID, new NodeDecoration("SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/IDOpenIcon.gif","SOFA/SOFAnode/Made/TIR/Access/TIRBrowser/images/IDCloseIcon.gif",null));
  }

  public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
    super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
    if (value instanceof TIRObjectNode) {
      TIRObjectNode node = (TIRObjectNode) value;
      int dk = 0;
      try {
        dk = node.obj.get_def_kind().value();
      } catch (java.rmi.RemoteException e) {}
      NodeDecoration n = nd.getND(dk);
      if (n != null) {
        if (expanded)
          setIcon(n.openIcon);
        else 
          setIcon(n.closeIcon);
      }  
    } 
    if (value instanceof RootNode) {
      NodeDecoration n = nd.getND(DefinitionKind.dk_Repository);
      if (n != null) {
        if (expanded)
          setIcon(n.openIcon);
        else 
          setIcon(n.closeIcon);
      }
    }
    if (value instanceof ProfileNode) {
      NodeDecoration n = nd.getND(DefinitionKind.dk_Profile);
      if (n != null) {
        if (expanded)
          setIcon(n.openIcon);
        else 
          setIcon(n.closeIcon);
      }
    }
    if (value instanceof IDNode) {
      NodeDecoration n = nd.getNDSpecial(NodeDecorationStore.ID);
      if (n != null) {
        if (expanded)
          setIcon(n.openIcon);
        else 
          setIcon(n.closeIcon);
      }
    }

    return this;
  }
}


class BaseNode extends DefaultMutableTreeNode {
  public BaseNode() {
    super();
  }
  public BaseNode(String s) {
    super(s);
  }
  public String[] getMenuNames() {
    return null;
  }
  public void performAction(String actionCommand, JTree tree, javax.swing.tree.TreePath selPath) {
    
  }
}


class RootNode extends BaseNode {
  Repository rep;
  Repository backRep;
  boolean hasContent;
  int repDefKind;

  public RootNode(String url, Repository r) {
    super(url);
    rep = r;
    backRep = r;
    repDefKind = DefinitionKind.dk_Repository;
    setAllowsChildren(true);
    hasContent = false;
    loadSubnodes();
  }

  public void loadSubnodes() {
    if (hasContent) {
      removeAllChildren();
    }
    try {
      Contained[] cnt = rep.contents(null);
      for (int i=0;i<cnt.length;i++) {
        add(new TIRObjectNode(cnt[i]));
      }
      add(new ProfilesNode(rep.getProfiles()));
      hasContent = true;
    } catch (TIRException e) {
       JOptionPane.showMessageDialog(null, "alert", "TIRException occured", JOptionPane.ERROR_MESSAGE);
    } catch (RemoteException e) {
       JOptionPane.showMessageDialog(null, "alert", "RemoteException occured", JOptionPane.ERROR_MESSAGE);
    }
  }

  public String[] getMenuNames() {
    if (repDefKind == DefinitionKind.dk_Repository) {
      String[] s = { "Open work repository", "Reload" };
      return s;
    } else {
      String[] s = { "Commit", "Abort" };
      return s;
    }
  }

  public void performAction(String actionCommand, JTree tree, javax.swing.tree.TreePath selPath) {
    if (actionCommand.compareTo("Reload")==0) {
      tree.collapsePath(selPath);
    /*  ((TreeBrowser)tree).clearTP(); 
      ((DefaultTreeModel)tree.getModel()).reload();
      int cnt = getChildCount();
      for (int i=0; i<cnt; i++) {
        TreeNode tn = getChildAt(i);
        if (tn instanceof TIRObjectNode) {
          ((TIRObjectNode) tn).removeContent();
        } else if (tn instanceof ProfilesNode) {
          ((ProfilesNode) tn).removeContent();
        } 
      }*/
      loadSubnodes();
      ((DefaultTreeModel)tree.getModel()).reload();
    } else if (actionCommand.compareTo("Open work repository")==0) {
      tree.collapsePath(selPath);
      try {
        WorkRepository wr = rep.beginChanges(null);
        rep = wr;
        repDefKind = DefinitionKind.dk_WorkRepository;
        loadSubnodes();
        ((DefaultTreeModel)tree.getModel()).reload();
      } catch (RemoteException e) {
        JOptionPane.showMessageDialog(tree, "alert", "Exception occured:\n"+e.getMessage(), JOptionPane.ERROR_MESSAGE);
      } catch (TIRExceptCreate e) {
        JOptionPane.showMessageDialog(tree, "alert", "Exception occured:\n"+e.getMessage(), JOptionPane.ERROR_MESSAGE);
      } catch (TIRExceptLock e) {
        JOptionPane.showMessageDialog(tree, "alert", "Exception occured:\n"+e.getMessage(), JOptionPane.ERROR_MESSAGE);
      }
    } else if (actionCommand.compareTo("Abort")==0) {
      tree.collapsePath(selPath);
      try {
        ((WorkRepository) rep).abort();
        rep = backRep;
        loadSubnodes();
        ((DefaultTreeModel)tree.getModel()).reload();
      } catch (RemoteException e) {
        JOptionPane.showMessageDialog(tree, "alert", "Exception occured:\n"+e.getMessage(), JOptionPane.ERROR_MESSAGE);
      }
    }
  }
}

class TIRObjectNode extends BaseNode {
  Contained obj;
  String label;
  boolean hasCont;
  
  public TIRObjectNode(Contained o) {
    hasCont = false;
    obj = o;
    if (obj instanceof SOFA.SOFAnode.Made.TIR.Container) {
      setAllowsChildren(true);
      add (new DefaultMutableTreeNode("Loading..."));
    }
    try {
      setTIRLabel();
    } catch (RemoteException e) {
      JOptionPane.showMessageDialog(null, "alert", "RemoteException occured", JOptionPane.ERROR_MESSAGE);
    }
  }

  public boolean hasContent() {
    return hasCont;
  }

  public void removeContent() {
    if (obj instanceof SOFA.SOFAnode.Made.TIR.Container) {
      removeAllChildren();
      setAllowsChildren(true);
      add (new DefaultMutableTreeNode("Loading..."));
      hasCont = false;
    }
  }

  public void loadContent() {
    if (obj instanceof SOFA.SOFAnode.Made.TIR.Container) {
      removeAllChildren();
      try {
        Contained cnt[] = ((SOFA.SOFAnode.Made.TIR.Container) obj).contents(null);
        for (int i=0;i<cnt.length;i++) {
          add(new TIRObjectNode(cnt[i]));
        }
        hasCont = true;
      } catch (TIRException e) {
        JOptionPane.showMessageDialog(null, "alert", "TIRException occured", JOptionPane.ERROR_MESSAGE);
      } catch (RemoteException e) {
        JOptionPane.showMessageDialog(null, "alert", "RemoteException occured", JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  protected void setTIRLabel() throws RemoteException {
    Identification id;
    DefinitionKind dk = obj.get_def_kind();
    switch (dk.value()) {
    case DefinitionKind.dk_CDLRepository:
      setUserObject("CDL");
      break;
    case DefinitionKind.dk_AModule:
    case DefinitionKind.dk_Provider:
    case DefinitionKind.dk_Module:
      id = obj.get_identification();
      label = kind2string(dk)+" "+id.name();
      setUserObject(label);
      break;
    default:
      id = obj.get_identification();
      label = kind2string(dk)+" "+id.name()+"?"+id.version();
      setUserObject(label);
    }
  }

  public static String kind2string(DefinitionKind dk) throws RemoteException {
    switch (dk.value()) {
      case DefinitionKind.dk_Attribute : return ("Attribute"); 
      case DefinitionKind.dk_Constant : return ("Constant"); 
      case DefinitionKind.dk_Exception : return ("Exception"); 
      case DefinitionKind.dk_Interface : return ("Interface"); 
      case DefinitionKind.dk_Module : return ("Module"); 
      case DefinitionKind.dk_Operation : return ("Operation"); 
      case DefinitionKind.dk_Typedef : return ("Typedef"); 
      case DefinitionKind.dk_Struct : return ("Struct"); 
      case DefinitionKind.dk_Union : return ("Union"); 
      case DefinitionKind.dk_Enum : return ("Enum"); 
      case DefinitionKind.dk_Primitive : return ("Primitive"); 
      case DefinitionKind.dk_String : return ("String"); 
      case DefinitionKind.dk_Sequence : return ("Sequence"); 
      case DefinitionKind.dk_Array : return ("Array"); 
      case DefinitionKind.dk_Repository : return ("Repository"); 
//      case DefinitionKind.dk_Template : return ("Template"); 
      case DefinitionKind.dk_Frame : return ("Frame"); 
      case DefinitionKind.dk_Architecture : return ("Architecture"); 
      case DefinitionKind.dk_Provides : return ("Provides"); 
      case DefinitionKind.dk_Requires : return ("Requires"); 
      case DefinitionKind.dk_Property : return ("Property"); 
//      case DefinitionKind.dk_ImplementationVer : return ("ImplementationVer"); 
      case DefinitionKind.dk_Implements : return ("Implements"); 
      case DefinitionKind.dk_Inst : return ("Inst"); 
      case DefinitionKind.dk_Bind : return ("Bind"); 
      case DefinitionKind.dk_Protocol : return ("Protocol"); 
      case DefinitionKind.dk_StructMember : return ("StructMember"); 
      case DefinitionKind.dk_EnumMember : return ("EnumMember"); 
      case DefinitionKind.dk_UnionMember : return ("UnionMember"); 
      case DefinitionKind.dk_Expression : return ("Expression"); 
      case DefinitionKind.dk_ProtocolOper : return ("ProtocolOper"); 
      case DefinitionKind.dk_ValueGen : return ("ValueGen"); 
      case DefinitionKind.dk_ValueGenElem : return ("ValueGenOper"); 
      case DefinitionKind.dk_BindOper : return ("BindOper"); 
      case DefinitionKind.dk_Provider : return ("Provider"); 
      case DefinitionKind.dk_AModule : return ("AModule"); 
      case DefinitionKind.dk_Wstring : return ("Wstring"); 
      case DefinitionKind.dk_Fixed : return ("Fixed"); 
      case DefinitionKind.dk_CDLRepository: return ("CDLRepository");
      case DefinitionKind.dk_WorkRepository : return ("WorkRepository");
    }
    return "";
  }

  public static String prim2string(PrimitiveKind p) throws RemoteException {
    switch (p.value()) {
    case PrimitiveKind.pk_void: return "void";
    case PrimitiveKind.pk_short: return "short";
    case PrimitiveKind.pk_long: return "long";
    case PrimitiveKind.pk_longlong: return "longlong";
    case PrimitiveKind.pk_ushort: return "ushort";
    case PrimitiveKind.pk_ulong: return "ulong";
    case PrimitiveKind.pk_ulonglong: return "ulonglong";
    case PrimitiveKind.pk_float: return "float";
    case PrimitiveKind.pk_double: return "double";
    case PrimitiveKind.pk_longdouble: return "longdouble";
    case PrimitiveKind.pk_boolean: return "boolean";
    case PrimitiveKind.pk_char: return "char";
    case PrimitiveKind.pk_wchar: return "wchar";
    case PrimitiveKind.pk_octet: return "octet";
    case PrimitiveKind.pk_object: return "object";
    case PrimitiveKind.pk_string: return "string";
    case PrimitiveKind.pk_wstring: return "wstring";
    case PrimitiveKind.pk_any: return "any";
    }
    return "";
  }

  public String[] getMenuNames() {
    try {
      DefinitionKind dk = obj.get_def_kind();
      switch (dk.value()) {
      case DefinitionKind.dk_Architecture:
        String[] s = { "Generate code" };
        return s;
      }
      return null;
    } catch (Exception e) { return null; }
  }

  public void performAction(String actionCommand, JTree tree, javax.swing.tree.TreePath selPath) {
    if (actionCommand.compareTo("Generate code")==0) {
      RunCodeGenDialog dd  = new RunCodeGenDialog(tree);
      dd.pack();
      ArchitectureDef[] archs = new ArchitectureDef [1];
      archs[0] = (ArchitectureDef) obj;
      dd.setVisible(true);
      dd.repaint();
      try {
        SOFA.SOFAnode.Made.CodeGen.Generator g = new SOFA.SOFAnode.Made.CodeGen.Generator((Repository) obj.get_containing_repository(), archs);
        g.generate();
        dd.setVisible(false);
      } catch (Exception ex) {
        JOptionPane.showMessageDialog(null, "alert", "Exception occured:\n"+ex.getMessage(), JOptionPane.ERROR_MESSAGE);
      }
    }
  }

}

class ProfilesNode extends BaseNode {
  ManageProfiles mp;
  boolean hasCont;

  public ProfilesNode(ManageProfiles m) {
    super("Profiles");
    mp = m;
    hasCont = false;
    setAllowsChildren(true);
    add (new DefaultMutableTreeNode("Loading..."));
  }

  public boolean hasContent() {
    return hasCont;
  }

  public void removeContent() {
    removeAllChildren();
    setAllowsChildren(true);
    add (new DefaultMutableTreeNode("Loading..."));
    hasCont = false;
  }

  public void loadContent() {
    removeAllChildren();
    try {
      ProfileDef[] cnt = mp.all_profiles();
      for (int i=0;i<cnt.length;i++) {
        add(new ProfileNode(cnt[i]));
      }
      hasCont = true;
    } catch (TIRException e) {
       JOptionPane.showMessageDialog(null, "alert", "TIRException occured", JOptionPane.ERROR_MESSAGE);
    } catch (RemoteException e) {
       JOptionPane.showMessageDialog(null, "alert", "RemoteException occured", JOptionPane.ERROR_MESSAGE);
    }
  }
}

class ProfileNode extends BaseNode {
  ProfileDef pr;
  boolean hasCont;

  public ProfileNode(ProfileDef p) {
    pr = p;
    hasCont = false;
    try {
      setUserObject(pr.name());
    } catch (RemoteException e) {
      JOptionPane.showMessageDialog(null, "alert", "RemoteException occured", JOptionPane.ERROR_MESSAGE);
    }
    setAllowsChildren(true);
    add (new DefaultMutableTreeNode("Loading..."));
  }

  public boolean hasContent() {
    return hasCont;
  }

  public void loadContent() {
    removeAllChildren();
    try {
      Identification[] cnt = pr.contents();
       for (int i=0;i<cnt.length;i++) {
        add(new IDNode(cnt[i]));
      }
      hasCont = true;     
    } catch (TIRException e) {
       JOptionPane.showMessageDialog(null, "alert", "TIRException occured", JOptionPane.ERROR_MESSAGE);
    } catch (RemoteException e) {
       JOptionPane.showMessageDialog(null, "alert", "RemoteException occured", JOptionPane.ERROR_MESSAGE);
    }
  }
}

class IDNode extends BaseNode {
  Identification id;
  boolean hasCont;

  public IDNode(Identification p) {
    id = p;
    try {
      setUserObject(id.absolute_name().name()+"?"+id.version());
    } catch (RemoteException e) {
      JOptionPane.showMessageDialog(null, "alert", "RemoteException occured", JOptionPane.ERROR_MESSAGE);
    }
    setAllowsChildren(false);
  }
}

  class MyTableModel extends AbstractTableModel {
    final String[] columnNames = {"Property", "Value"};

    TIRObject obj;
    Object[][] data;
    int rows;
    String host, port;
    SOFA.SOFAnode.Made.CodeGen.JavaMapping jm = new SOFA.SOFAnode.Made.CodeGen.JavaMapping();
    SOFA.SOFAnode.Made.CodeGen.IDLMapping im = new SOFA.SOFAnode.Made.CodeGen.IDLMapping();

    public MyTableModel(String host, String port) {
      super();
      this.host = host;
      this.port = port;
    }

    private void setData(int i,String s1, String s2) {
      data[i][0] = s1;
      data[i][1] = s2;
    }

    private String cdlType2String(CDLType t) throws RemoteException {
      StringBuffer sb = new StringBuffer();
      if (t instanceof Contained) {
        Identification id = ((Contained) t).get_identification();
        sb.append(id.absolute_name().name());
        sb.append("?");
        sb.append(id.version());
      } else {
        switch (((TIRObject)t).get_def_kind().value()) {
        case DefinitionKind.dk_Primitive:
          sb.append(TIRObjectNode.prim2string(((PrimitiveDef)t).kind()));
          break;
        case DefinitionKind.dk_Array:
          sb.append(cdlType2String(((ArrayDef)t).element_type()));
          sb.append("[]");
          break;
        case DefinitionKind.dk_Sequence:
          sb.append("sequence < ");
          sb.append(cdlType2String(((SequenceDef)t).element_type()));
          sb.append(" >");
          break;
        case DefinitionKind.dk_String:
          sb.append("string");
          break;
        case DefinitionKind.dk_Wstring:
          sb.append("wstring");
          break;
        }
      }
      return sb.toString();
    }

    public void setObj(TIRObject obj) {
      int i;
      rows = 0;
      this.obj = obj;
      if (data==null) {
        int len = 15;
        data = new Object[len][];
        for (i=0;i<len;i++)
         data[i] = new Object[2];
      }
      try {
        int dk = obj.get_def_kind().value();
        setData(rows,"Kind", TIRObjectNode.kind2string(obj.get_def_kind()));
        rows++;
        
        if (dk == DefinitionKind.dk_Repository || dk == DefinitionKind.dk_WorkRepository) {
          setData(rows,"Host", host);
          setData(rows+1,"Port", port);
          rows += 2;
        }
        if (dk == DefinitionKind.dk_CDLRepository) {
          setData(rows,"Name","CDLRepository");
          rows++;
        } else if (obj instanceof Contained) {
          Identification id = null;
          if (obj instanceof Contained)
            id = ((Contained) obj).get_identification();
          setData(rows,"Name",id.name());
          rows++;
          if (!moduleType(dk)) {
            setData(rows,"Version", id.version());
            rows++;
          }
          StringBuffer sb;
          switch (dk) {
          case DefinitionKind.dk_Typedef:
            setData(rows, "Original type", cdlType2String(((TypedefDef)obj).original_type()));
            rows++;
            break;
          case DefinitionKind.dk_Architecture:
            setData(rows, "System", (new Boolean(((ArchitectureDef) obj).is_system())).toString());
            rows++;
            setData(rows, "Frame", cdlType2String(((ArchitectureDef) obj).frame()) );
            rows++;
            break;
          case DefinitionKind.dk_Attribute:
            setData(rows, "Type", cdlType2String(((AttributeDef) obj).type()));
            rows++;
            if (((AttributeDef)obj).mode().value() == AttrMode.ATTR_NORMAL)
              setData(rows, "Mode", "normal");
            else
              setData(rows, "Mode", "read-only");
            rows++;
            break;
          case DefinitionKind.dk_Enum:
            EnumMember[] memb = ((EnumDef)obj).members();
            String em = "";
            for (i=0;i<memb.length;i++) {
              em += memb[i].name();
              if (i!=memb.length-1)
                em+=", ";
            }
            setData(rows, "Members", em);
            rows++;
            break;
          case DefinitionKind.dk_Frame:
            setData(rows, "System", (new Boolean(((FrameDef) obj).is_system())).toString());
            rows++;
            break;
          case DefinitionKind.dk_Inst:
            setData(rows, "Type", cdlType2String(((InstDef) obj).type()));
            rows++;
            if (((InstDef)obj).mode().value() == InstMode.NORMAL)
              setData(rows, "Mode", "normal");
            else
              setData(rows, "Mode", "auto");
            rows++;
            break;
          case DefinitionKind.dk_Interface:
            InterfaceDef[] base = ((InterfaceDef) obj).base_interfaces();
            sb = new StringBuffer();
            for (i=0;i<base.length;i++) {
              sb.append(cdlType2String(base[i]));
              if (i!=base.length-1)
                sb.append(", ");
            }
            setData(rows, "Base Interfaces", sb.toString());
            rows++;
            sb = null;
            break;
          case DefinitionKind.dk_Bind:
            setData(rows, "Using", ((BindDef) obj).using());
            rows++;
            break;
          }
/*          if (obj instanceof CDLType && !(obj instanceof ArchitectureDef)) {
            String s = jm.getImplTypeName((CDLType) obj);
            if (s==null)
              s = "null";
            setData(rows, "JAVA generated type", s);
            rows++;
            s = im.getImplTypeName((CDLType) obj);
            if (s==null)
              s = "null";
            setData(rows, "IDL generated type", s);
            rows++;
          } */
        }
      } catch (java.rmi.RemoteException e) {
        rows=1;
        data[0][0] = "Error";
        data[0][1] = "RemoteException occured";
      } catch (TIRException e) {
        rows=1;
        data[0][0] = "Error";
        data[0][1] = "TIRException occured";
      }
      fireTableStructureChanged(); 
    }

    private boolean moduleType(int dk) {
      if (dk==DefinitionKind.dk_Module ||
          dk==DefinitionKind.dk_AModule ||
          dk==DefinitionKind.dk_Provider 
         )
        return true;
      else
       return false;
    }

    public int getColumnCount() {
      return 2;
    }
    
    public int getRowCount() {
      return rows;
    }

    public String getColumnName(int col) {
      return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
      return data[row][col];
    }

    public boolean isCellEditable(int row, int col) {
      return false;
    }

  }
