/* $Id: ContainedImpl.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

public abstract class ContainedImpl extends UnicastRemoteObject implements Contained, TIRImplObject, SContained {
  protected Identification id;
  protected Container parent;
  protected Repository rep;
  
  public ContainedImpl(Identification ident, Container in, Repository inrep) throws RemoteException {
    id = ident;
    parent = in;
    rep = inrep;
  }

  public ContainedImpl() throws RemoteException {
    id = null;
    parent = null;
    rep = null;
  }

  public Identification get_identification() throws RemoteException {
    return id;
  }

  public Container get_defined_in() throws RemoteException {
    return parent;
  }
  
  public Container get_containing_repository() throws RemoteException {
    return rep;
  }

  public AbsoluteName get_absolute_name() throws RemoteException {
    AbsoluteNameImpl absName;
/*    if (rep == parent) {  // object is contained in repository
      absName = new AbsoluteNameImpl("::"+id.name());
    } else { */
      absName = new AbsoluteNameImpl(((SContained)parent).get_absolute_name().name()+"::"+id.name());
 /*   }  */
    return (AbsoluteName) absName;
  }

  public void tag(String t) throws RemoteException, TIRExceptCreate, TIRExceptLock {
    String ebt = id.branchTag();
    if (t.compareTo(ebt)==0)
      throw new TIRExceptCreate("This tag exists");
    String[] et = id.tag();
    int i,j;
    for (i=0;i<et.length;i++) {
      if (t.compareTo(et[i])==0)
       throw new TIRExceptCreate("This tag exists");       
    }
    Contained[] sibl = parent.lookup_name(id);
    for (j=0;j<sibl.length;j++) {
      Identification idl = sibl[j].get_identification();
      
      ebt = idl.branchTag();
      if (t.compareTo(ebt)==0)
        throw new TIRExceptCreate("This tag exists");
      et = idl.tag();
      for (i=0;i<et.length;i++) {
        if (t.compareTo(et[i])==0)
          throw new TIRExceptCreate("This tag exists");       
      } 
    }
    ((SIdentification) id).tag(t);
  }

}
