/* $Id: ProtocolMetaOperandDefImpl.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.*;

public class ProtocolMetaOperandDefImpl extends UnicastRemoteObject implements ProtocolMetaOperandDef, TIRImplObject, SProtocolOperDef {
  String nm;
  ProtocolOperKind pok;
  DefinitionKindImpl defKindImpl;
  StateKindImpl stKindImpl;
  

  public ProtocolMetaOperandDefImpl(String name) throws RemoteException {
    nm = name;
    pok = new ProtocolOperKindImpl(ProtocolOperKind.pok_metaoperand);
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_ProtocolOper);
    stKindImpl = new StateKindImpl(StateKind.sk_work);
  }

  public ProtocolMetaOperandDefImpl() throws RemoteException {
    nm = null;
    pok = new ProtocolOperKindImpl(ProtocolOperKind.pok_metaoperand);
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_ProtocolOper);
    stKindImpl = new StateKindImpl(StateKind.sk_normal);
  }

  public ProtocolOperKind get_po_kind() throws RemoteException {
    return pok;
  }

  /* from interface TIRObject */
  public DefinitionKind get_def_kind() throws RemoteException {
    return (DefinitionKind) defKindImpl;
  }

  /* from interface TIRObject */
  public StateKind get_state() throws RemoteException {
    return (StateKind) stKindImpl;
  }

  public String name() throws RemoteException {
    return nm;
  }
  
  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      st.curOutFile.writeInt(pok.value());
      Storage.writeString(st.curOutFile, nm);
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't write in directory "+st.current+".");
    }
  }
  
  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      nm = Storage.readString(st.curInFile);
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't read in directory "+st.current+".");
    }
  }

  public void postLoad(RepositoryImpl r) throws RemoteException, TIRExceptStorage {
  }

  public boolean isNew() {
    return (stKindImpl.value()==StateKind.sk_work);
  }

  public void canCommit() throws RemoteException, TIRExceptCommit {;}

  public void doCommit(Container in, Repository rep) throws RemoteException {
    if (stKindImpl.value()==StateKind.sk_normal)
      return;
    stKindImpl.toNormal();
  }

  public void doAbort(long workId) throws RemoteException {}

  public String to_text() throws RemoteException {
    StringBuffer sb = new StringBuffer("[");
    sb.append(nm);
    sb.append("]");
    return sb.toString();
  }
}
