/* $Id: InterfaceDef.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** Interface for the <b>CDL Inteface</b>. */
public interface InterfaceDef extends Container, Contained, CDLType {
  /** Base interfaces of this interface. */
  public InterfaceDef[]   base_interfaces() throws RemoteException;
  /** Protocol of this interface */
  public ProtocolDef      protocol() throws RemoteException;

  /** Set base interfaces. */
  public void setBaseInterfaces(InterfaceDef[] base_interfaces) throws RemoteException, TIRExceptCreate;
  /** Create new constant in this interface. */
  public ConstantDef create_constant(Identification id, CDLType type, ExprOperDef value) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new struct in this interface. */
  public StructDef create_struct(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new union in this interface. */
  public UnionDef create_union(Identification id, CDLType switch_type) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new enum in this interface. */
  public EnumDef create_enum(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new typedef in this interface. */
  public TypedefDef   create_typedef(Identification id, CDLType orig_type) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new exception in this interface. */
  public ExceptionDef create_exception(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
   /** Create new attribute in this interface. */ 
  public AttributeDef create_attribute(Identification name, CDLType type, int mode) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new operation in this interface. */
  public OperationDef create_operation(Identification name, CDLType result, ExceptionDef[] exceptions) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create protocol of this interface. */
  public ProtocolDef create_protocol() throws RemoteException, TIRExceptCreate, TIRExceptLock;
}
