/* $Id: ProtocolSequence.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */

package SOFA.SOFAnode.Util;

import java.util.*;

class ProtocolSequence extends ProtocolBinaryOperator {

    public ProtocolSequence( Protocol l, Protocol r ) {
	super( ";",l,r );
    }

    public Protocol Copy() {
	return new ProtocolSequence( left.Copy(), right.Copy() );
    }
        
    public Machine createMachine() {
        machineImpl result = (machineImpl)left.createMachine();
	machineImpl m = (machineImpl)right.createMachine();

        if( m.Stop().containsKey( new Integer(m.Start()) ) ) { // starting state of m is also accepting state
	    Debug.println(3, "Sequence build start is stop " );
	    
	    Debug.println(3, "Sequence first machine:");
	    ((Printer)result).Print(3);
	    Debug.println(3, "Sequence second machine:");
	    ((Printer)m).Print(3);
	    	    
	    Debug.println(3, "Sequence result after new copy for start state" );
	    ((Printer)result).Print(3);

	    int map[] = result.AddStates( m.states, m.nextID );
	    
	    Iterator i = result.Stop().values().iterator();
	    while( i.hasNext() )
		result.Merge( ((Integer)i.next()).intValue(), map[m.Start()] );

	    for( i = m.Stop().values().iterator(); i.hasNext() ; )
		result.AddStop( map[ ((Integer)i.next()).intValue()] );
	    for( i = m.Update().values().iterator(); i.hasNext() ; )
		result.addUpdateEdge( map[ ((Integer)i.next()).intValue()] );
	    
	} else {                               // starting state is not same as accepting state
	    Debug.println(3, "Sequence build start is not stop " );
	    int map[] = result.AddStates( m.states, m.nextID );

	    Iterator i = result.Stop().values().iterator();
	    while( i.hasNext() )
		result.Merge( ((Integer)i.next()).intValue(), map[m.Start()] );

	    result.ClearStops();

	    for( i = m.Stop().values().iterator(); i.hasNext() ; )
		result.AddStop( map[ ((Integer)i.next()).intValue()] );
	    for( i = m.Update().values().iterator(); i.hasNext() ; )
		result.addUpdateEdge( map[ ((Integer)i.next()).intValue()] );

	    ((Printer)result).Print(3);
	}
	
	result.Minimize();

	Debug.println(2,"Sequence result:");
	((Printer)result).Print(2);
    
	return result;    
    }

    public Protocol getSameType( Object p1, Object p2 ) {
	return new ProtocolSequence( (Protocol)p1, (Protocol)p2 );
    }
}

